--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.Std_Logic_1164.all;
USE IEEE.Std_Logic_Unsigned.all;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ENTITY configurable_u30 IS
  PORT(
      A    : IN std_logic_vector(7 downto 0);
      B    : IN std_logic_vector(7 downto 0);
      S    : OUT std_logic_vector(7 downto 0)
  );
END configurable_u30;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ARCHITECTURE structure OF configurable_u30 IS
--------------------------------------------------------------------------------
SIGNAL SA : std_logic_vector(8 downto 0);
SIGNAL SB : std_logic_vector(8 downto 0);
--------------------------------------------------------------------------------
BEGIN
    SA(7 downto 0) <= A;
    SA(8) <= '0';
    SB(7 downto 0) <= B;
    SB(8) <= '0';
    PROCESS(SA, SB)
    VARIABLE SS : std_logic_vector(8 downto 0);
    BEGIN
        SS := SA + SB;
        S(7 downto 0) <= SS(7 downto 0);
    END PROCESS;
END structure;
--------------------------------------------------------------------------------
